package com.kdanmobile.reader.screen.model

import android.graphics.RectF
import com.kdanmobile.kmpdfkit.pdfcommon.TextWord

class SearchResultInfo {
    lateinit var result: String
    var page: Int = 0
    lateinit var rf: RectF
    lateinit var search: String
    lateinit var line: Array<TextWord>

    constructor() {

    }

    constructor(result: String, page: Int) {
        this.result = result
        this.page = page
    }

    constructor(page: Int, search: String, rf: RectF, line: Array<TextWord>) {
        this.page = page
        this.search = search
        this.rf = rf
        this.line = line
        result = ""
        for (aLine in line) {
            result = result + aLine.w + " "
        }

        this.result = replace(result, search)
    }

    private fun replace(result: String, search: String): String {
        var result = result
        val sb = StringBuilder()
        var src = result.toLowerCase()
        val seh = search.toLowerCase()
        var index = src.indexOf(seh)
        while (index >= 0) {
            sb.append(src.subSequence(0, index))
            sb.append("<font color=\"#ff0000\">")
            result = result.substring(index)
            sb.append(result.substring(0, search.length))
            sb.append("</font>")
            result = result.substring(search.length)
            src = src.substring(index + search.length)
            index = src.indexOf(seh)
        }

        sb.append(result)

        return sb.toString()
    }
}
